=== debian/changelog ===
gromacs (2026.0-1) experimental; urgency=medium

  * New upstream version 2026.0
  * Further cleanups for removed documentation.
  * Update to watch format v5.
  * Update to Standards-Version 4.7.3.
  * Remove chrpath workaround, no longer needed (#1085509).
  * Remove disable-gmxtimingtests.patch - mips-specific, now obsolete.
  * Exclude specific tests on riscv64 and s390x.

 -- Nicholas Breen <nbreen@debian.org>  Mon, 02 Mar 2026 19:45:29 -0800
