=== debian/watch ===
Version: 5

Source: https://ftp.gromacs.org/gromacs/
Matching-Pattern: gromacs-([\d\.betaprc_-]*)\.tar\.gz
Uversionmangle: s/[-_]((pre|beta|rc)[^.]*)/~$1/

Component: regressiontests
Source: https://ftp.gromacs.org/regressiontests/
Matching-Pattern: regressiontests-([\d\.betaprc_-]*)\.tar\.gz
Uversionmangle: s/[-_]((pre|beta|rc)[^.]*)/~$1/
